<template>
  <div>
    <el-dialog title="批量修改等级" custom-class="customer-dailog" :visible.sync="dialogVisible"
      :close-on-click-modal="false" @close="cancel" width="600px">
      <div class="checkedCustomers">当前选中<span class="num"> {{ multipleList.length }} </span>位客户
      </div>
      <el-form ref="form" :model="form" :rules="rules" label-width="133px">
        <el-form-item v-if="showEditClique" label="等级类型：" prop="gradeType">
          <el-radio v-model="form.isClique" :label="1" @change="form.gradeId = ''">集团等级</el-radio>
          <el-radio v-model="form.isClique" :label="0" @change="form.gradeId = ''">商户等级</el-radio>
        </el-form-item>
        <el-form-item label="调整后等级：" prop="gradeId">
          <el-select v-model="form.gradeId" placeholder="请选择" style="width: 400px;">
            <el-option v-for="item in gradeList" :key="item.id" :label="item.name" :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="原因备注：" prop="remark">
          <el-input type="text" maxlength="20" show-word-limit v-model="form.remark"
            style="width: 400px;"></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" :loading="btnLoading" @click="submit">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import { doFetch, doFetchqs } from "../../axios/api";
import url from "../../axios/url";
import { mapState } from "vuex";
import { checkFalse, checkStatus, checkSuccess } from "../../../../static/js/checkStatus";
export default {
  name: "gradeDailog",
  props: {
    dialogVisible: {
      type: Boolean,
      default: false
    },
    multipleList: {
      type: Array,
      default: () => {
        return [];
      }
    },
    gradeList: {
      type: Array,
      default: () => {
        return [];
      }
    },
    pageSize: {
      type: Number,
      default: ''
    },
    memberSearchStr: {
      type: Number,
      default: ''
    },
    phoneNameCard: {
      type: String,
      default: ''
    },
    pageName: {
      type: String,
      default: ''
    },
  },
  data() {
    return {
      form: {
        gradeId: "",
        remark: "",
        isClique: 0
      },
      rules: {
        gradeId: [ { required: true, message: "请选择等级", trigger: "change" } ],
        remark: [
          { required: true, message: "请输入原因备注", trigger: "change" }
        ]
      },
      btnLoading: false,
    };
  },
  computed: {
    ...mapState([ "showEditClique" ])
  },
  methods: {
    cancel() {
      this.$refs[ 'form' ].resetFields();
      this.$emit('update:dialogVisible', false);
    },
    submit() {
      this.$refs[ 'form' ].validate(valid => {
        if (valid) {
          this.btnLoading = true;
          let memberIdsArr = [];
          this.multipleList.forEach(item => {
            memberIdsArr.push(item.memberId);
          });
          doFetch(url.updateGrade, Object.assign({}, this.form, {
            memberIds: this.selectAll == true ? "-1" : memberIdsArr.join(","),
            isCurrent: this.selectAll == true ? 2 : this.multipleList.length == this.pageSize ? 1 : 0,
            memberSearchParamStr: this.selectAll == true ? (this.memberSearchStr ? this.memberSearchStr : "-1") : "",
            phoneNameCard: this.phoneNameCard,
            pageName: this.pageName
          }))
            .then(res => {
              if (res.data.errorCode === 0) {
                setTimeout(() => {
                  this.btnLoading = false;
                  checkSuccess();
                  this.$refs[ 'form' ].resetFields();
                  this.$emit('update:dialogVisible', false);
                  this.$emit('refresh');
                }, 4500);
              } else {
                checkFalse();
                this.btnLoading = false;
              }
            })
            .catch(err => {
              this.btnLoading = false;
              checkStatus(err);
            });
        } else {
          return false;
        }
      });
    },
  },
  watch: {
    dialogVisible(n, o) {
      if (n) {
        if (this.showEditClique) {
          this.form.isClique = 1;
        }
      }
    }
  }
};

</script>
<style lang="less" scoped>
.customer-dailog {
  .checkedCustomers {
    margin-left: 133px;
    margin-bottom: 20px;
    font-size: 14px;
    font-weight: 400;
    color: #909399;
    line-height: 20px;
    .num {
      color: #303133;
    }
  }
  .sub-tip {
    margin: 4px 0 -5px;
    font-size: 12px;
    font-weight: 400;
    color: #909399;
    line-height: 17px;
  }
}
</style>
<style lang="less">
// 去除dailog-footer上边框
.customer-dailog .el-dialog__footer {
  padding-top: 0;
  padding-bottom: 20px;
  border-top: none !important;
}
.customer-dailog .el-dialog__body {
  padding-bottom: 0;
}
</style>